/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the SlaceConnect type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SlaceConnect{}

// SlaceConnect struct for SlaceConnect
type SlaceConnect struct {
	RolloutId string `json:"rollout_id"`
	InteractionName string `json:"interaction_name"`
	CxId *string `json:"cx_id,omitempty"`
}

// NewSlaceConnect instantiates a new SlaceConnect object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSlaceConnect(rolloutId string, interactionName string) *SlaceConnect {
	this := SlaceConnect{}
	this.RolloutId = rolloutId
	this.InteractionName = interactionName
	return &this
}

// NewSlaceConnectWithDefaults instantiates a new SlaceConnect object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSlaceConnectWithDefaults() *SlaceConnect {
	this := SlaceConnect{}
	return &this
}

// GetRolloutId returns the RolloutId field value
func (o *SlaceConnect) GetRolloutId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.RolloutId
}

// GetRolloutIdOk returns a tuple with the RolloutId field value
// and a boolean to check if the value has been set.
func (o *SlaceConnect) GetRolloutIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.RolloutId, true
}

// SetRolloutId sets field value
func (o *SlaceConnect) SetRolloutId(v string) {
	o.RolloutId = v
}

// GetInteractionName returns the InteractionName field value
func (o *SlaceConnect) GetInteractionName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.InteractionName
}

// GetInteractionNameOk returns a tuple with the InteractionName field value
// and a boolean to check if the value has been set.
func (o *SlaceConnect) GetInteractionNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.InteractionName, true
}

// SetInteractionName sets field value
func (o *SlaceConnect) SetInteractionName(v string) {
	o.InteractionName = v
}

// GetCxId returns the CxId field value if set, zero value otherwise.
func (o *SlaceConnect) GetCxId() string {
	if o == nil || IsNil(o.CxId) {
		var ret string
		return ret
	}
	return *o.CxId
}

// GetCxIdOk returns a tuple with the CxId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SlaceConnect) GetCxIdOk() (*string, bool) {
	if o == nil || IsNil(o.CxId) {
		return nil, false
	}
	return o.CxId, true
}

// HasCxId returns a boolean if a field has been set.
func (o *SlaceConnect) HasCxId() bool {
	if o != nil && !IsNil(o.CxId) {
		return true
	}

	return false
}

// SetCxId gets a reference to the given string and assigns it to the CxId field.
func (o *SlaceConnect) SetCxId(v string) {
	o.CxId = &v
}

func (o SlaceConnect) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SlaceConnect) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["rollout_id"] = o.RolloutId
	toSerialize["interaction_name"] = o.InteractionName
	if !IsNil(o.CxId) {
		toSerialize["cx_id"] = o.CxId
	}
	return toSerialize, nil
}

type NullableSlaceConnect struct {
	value *SlaceConnect
	isSet bool
}

func (v NullableSlaceConnect) Get() *SlaceConnect {
	return v.value
}

func (v *NullableSlaceConnect) Set(val *SlaceConnect) {
	v.value = val
	v.isSet = true
}

func (v NullableSlaceConnect) IsSet() bool {
	return v.isSet
}

func (v *NullableSlaceConnect) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSlaceConnect(val *SlaceConnect) *NullableSlaceConnect {
	return &NullableSlaceConnect{value: val, isSet: true}
}

func (v NullableSlaceConnect) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSlaceConnect) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


